=== debian/changelog ===
ros-ardent-ros1-bridge (0.4.0-0xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Dirk Thomas <dthomas@osrfoundation.org>  Sat, 09 Dec 2017 09:16:18 -0000
