=== debian/control ===
Source: ros-ardent-ros1-bridge
Section: misc
Priority: extra
Maintainer: Dirk Thomas <dthomas@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), python-rospkg, ros-kinetic-actionlib-msgs, ros-kinetic-catkin, ros-kinetic-common-msgs, ros-kinetic-geometry-msgs, ros-kinetic-nav-msgs, ros-kinetic-rosbash, ros-kinetic-roscpp, ros-kinetic-roscpp-tutorials, ros-kinetic-roslaunch, ros-kinetic-rosmsg, ros-kinetic-rospy-tutorials, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-std-srvs, ros-kinetic-stereo-msgs, ros-kinetic-tf2-msgs, ros-kinetic-trajectory-msgs, ros-kinetic-visualization-msgs, pkg-config, python3-yaml, ros-ardent-actionlib-msgs, ros-ardent-ament-cmake, ros-ardent-ament-cmake-pytest, ros-ardent-ament-index-python, ros-ardent-ament-lint-auto, ros-ardent-ament-lint-common, ros-ardent-demo-nodes-cpp, ros-ardent-diagnostic-msgs, ros-ardent-geometry-msgs, ros-ardent-launch, ros-ardent-nav-msgs, ros-ardent-rclcpp, ros-ardent-rcutils, ros-ardent-rmw-implementation-cmake, ros-ardent-ros2run, ros-ardent-rosidl-cmake, ros-ardent-rosidl-parser, ros-ardent-sensor-msgs, ros-ardent-shape-msgs, ros-ardent-std-msgs, ros-ardent-std-srvs, ros-ardent-stereo-msgs, ros-ardent-tf2-msgs, ros-ardent-trajectory-msgs, ros-ardent-visualization-msgs, ros-ardent-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-ardent-ros1-bridge
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python-rospkg, ros-kinetic-actionlib-msgs, ros-kinetic-catkin, ros-kinetic-common-msgs, ros-kinetic-geometry-msgs, ros-kinetic-nav-msgs, ros-kinetic-rosbash, ros-kinetic-roscpp, ros-kinetic-roscpp-tutorials, ros-kinetic-roslaunch, ros-kinetic-rosmsg, ros-kinetic-rospy-tutorials, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-std-srvs, ros-kinetic-stereo-msgs, ros-kinetic-tf2-msgs, ros-kinetic-trajectory-msgs, ros-kinetic-visualization-msgs, python3-yaml, ros-ardent-actionlib-msgs, ros-ardent-diagnostic-msgs, ros-ardent-geometry-msgs, ros-ardent-nav-msgs, ros-ardent-rclcpp, ros-ardent-rcutils, ros-ardent-sensor-msgs, ros-ardent-shape-msgs, ros-ardent-std-msgs, ros-ardent-std-srvs, ros-ardent-stereo-msgs, ros-ardent-tf2-msgs, ros-ardent-trajectory-msgs, ros-ardent-visualization-msgs, ros-ardent-ros-workspace
Description: A simple bridge between ROS 1 and ROS 2
